package ru.dbotthepony.mc.otm.network.syncher

import net.minecraft.network.RegistryFriendlyByteBuf
import ru.dbotthepony.kommons.util.Observer

interface ISynchable : Observer {
	fun read(stream: RegistryFriendlyByteBuf)

	/**
	 * Provided [listener] is to be considered thread-safe, and can be called at any time
	 *
	 * Created [IRemoteState] is implied to have [IRemoteState.invalidate] called implicitly internally
	 */
	fun createRemoteState(listener: Runnable): IRemoteState

	val shouldBeObserved: Boolean
		get() = false

	override fun observe(): Boolean {
		// no op
		return false
	}
}
